from PyQt6.QtCore import QSysInfo


class StringHolder:

    value = None

    @classmethod
    def set_value(cls):
        # needs to be set here, setting from outside doesn't trigger the crash.
        # anything that returns a QString from Qt/C++
        cls.value = QSysInfo.productType()


class StringHolderSub(StringHolder):

    # needs to be subclass, moving this to StringHolder doesn't trigger the
    # crash.

    def get_value(self, value):
        return value.replace('placeholder', self.value)


if __name__ == "__main__":
    for _ in range(1010):  # triggers exactly after 1010 times.
        StringHolder.set_value()
        StringHolderSub.value
